stages:
  - docker
  - build
  - test
  - coverage
  - upload

variables:
  DOCKER_IMAGE: docker:23
  CONTAINER_IMAGE: $CI_REGISTRY_IMAGE:latest
  GIT_SUBMODULE_STRATEGY: recursive

image: $CONTAINER_IMAGE

docker:
  image: $DOCKER_IMAGE
  stage: docker
  services:
    - $DOCKER_IMAGE
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build --cache-to type=inline --cache-from $CONTAINER_IMAGE -t $CONTAINER_IMAGE .
    - docker push $CONTAINER_IMAGE
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      changes:
        - Dockerfile

build_release:
  stage: build
  script:
    - export CC=clang CXX=clang++
    - cmake -G Ninja -DCMAKE_BUILD_TYPE=Release -B build
    - cmake --build build --target install
  artifacts:
    paths:
      - build/
      - programs/

build_coverage:
  stage: build
  script:
    - export CC=clang CXX=clang++
    - cmake -G Ninja -DCMAKE_BUILD_TYPE=Coverage -B build
    - cmake --build build --target tests
  artifacts:
    paths:
      - build/

test:
  stage: test
  script:
    - ctest -VV --test-dir build --output-junit junit.xml
  needs:
    - build_release
  artifacts:
    reports:
      junit: build/junit.xml

coverage:
  stage: coverage
  script:
    - cmake --build build --target coverage
  needs:
    - test
    - build_coverage
  coverage: /functions.*%/
  artifacts:
    paths:
      - coverage/

upload:
  stage: upload
  script:
    - FILE_PATH=$CI_API_V4_URL/projects/$CI_PROJECT_ID/packages/generic/ctl-model-checker/1.0/ctl-model-checker
    - 'curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file programs/ctl-model-checker $FILE_PATH'
  needs:
    - test
    - build_release
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: manual
